def fn make_sprites_appsub (rows%,xcsize%,ycsize%)
local cols%,c%
  cols%=  3				: rem 3 cols per row
  c%=(rows%+1)*cols%			: rem this is the total number of objects
  c%=c%-1				: rem but counting starts at 0
  return make_sprites_appsub2 (c%,cols%,xcsize%,ycsize%)
end def make_sprites_appsub
:
def fn make_sprites_appsub2 (count%,cols%,xcsize%,ycsize%)
rem make an appsub window with	with the system sprites and 2 strings per row
rem this uses the global colour vars sp.xxxxxx
local iattr(3,3),jus%(count%,1),sk$,type%(count%),strg$(count%,20),pspr(count%)
local pblb(count%),ppat(count%),lp%,csp%,cst%
local aolst,cdef,sizex%(cols%-1,1),sizey%(0,1),xaslst,yaslst,rwlst,se%(count%,1)
local wdeff%(3),apw(0),wattr%(3),awlst,temp%
rem we want count% +1 objects!!!!!!!
  restore
  rd_iatt iattr 			: rem read the item attributes
    data 1,sp.appihigh
    data sp.appiunabg,sp.appiunafg,0,0	: rem unavialable
    data sp.appiavabg,sp.appiavafg,0,0	: rem available
    data sp.appiselbg,sp.appiselfg,0,0	: rem selected
  csp%=0				: rem this is the sprite counter
  cst%=0				: rem the string objects counter
  sk$=""				: rem selection keys
  rem let's have some fun : if the height is not double, use a msall sprite
  rem (the same one everywhere), else use system sprites
  if ycsize%
    for lp%=0 to count% div cols%
      pspr(csp%)=lp%			: rem first object/row = system sprite
      type%(lp%*cols%)=2+retn		: rem set type byte to sprite + autoreturn
      csp%=csp%+1			: rem increase sprite pointer
      strg$(cst%)="Row "&(cst% div 2)	: rem first str obj in row
      cst%=cst%+1			: rem prepare for next string object
      strg$(cst%)="Just some string":	: rem 2nd string obj
      cst%=cst%+1			: rem prepare for next string object
      type%(lp%*cols%+1)=retn		: rem make automatic return if hit
      type%(lp%*cols%+2)=retn
      sk$=sk$&chr$(65+lp%)&chr$(0)&chr$(0): rem selkeys for all ojects in one row
    end for lp%
    pspr(0)=sys_tspr_addr(0)		: rem else this would be a 0 (invisible) object
  else
    for lp%=0 to count% div cols%
      pspr(csp%)=3			: rem first object per row =  small sprite
      type%(lp%*cols%)=2+retn		: rem set type byte to sprite + autoreturn
      csp%=csp%+1			: rem increase sprite pointer
      strg$(cst%)="Row "&(cst% div 2)	: rem first str obj in row
      cst%=cst%+1			: rem prepare for next string object
      strg$(cst%)="Just some string":	: rem 2nd string obj
      cst%=cst%+1			: rem prepare for next string object
      type%(lp%*cols%+1)=retn		: rem make automatic return if hit
      type%(lp%*cols%+2)=retn
      sk$=sk$&chr$(65+lp%)&chr$(0)&chr$(0): rem selkeys for all ojects in one row
    end for lp%
  endif
:
  rem now make appsub object list and control definition
  aolst=mk_aol(iattr,jus%,sk$,type%,strg$,pspr,pblb,ppat)
  cdef=mk_cdef(1,sp.scrbararr,sp.scrbar,sp.scrbarsec)
:
  rem now make spacing lists
  rem first the spacing of the columns = x spacing list
  select on xcsize%
    =0 : temp% = 6			: rem how wide is a char?
    =1 : temp% = 8
    =2 : temp% = 12
    =3 : temp% = 16
  end select
  dim sizex%(cols%-1,1) 		: rem x spacing list, 1 elemt per column
  sizex%(0,0)=34:sizex%(0,1)=38 	: rem xsize of column 1
  temp%=temp%*6 			: rem col 2 has 6 chars max
  sizex%(1,0)= temp%			: rem x hitsize of col2 depends on size of char
  sizex%(1,1)= temp%+4			: rem x spacing
  temp%=xsize%-26			: rem width of appsub wdw
  temp%=temp%-sizex%(0,1)-sizex%(1,1)-4 : rem - space taken by first 2 vols
  sizex%(2,1)=temp%			: rem = space for last col
  sizex%(2,0)=temp%-4			: rem and smaller hitsize
  rem now the spacing of the rows = y spacing list
  dim sizey%(rows%,1)			: rem number of rows
  if ycsize%
    for lp%=0 to rows%
       sizey%(lp%,0)=22 		: rem height of object hitsize, in pixels
       sizey%(lp%,1)=24 		: rem height of object spacing
    end for lp%
  else
    for lp%=0 to rows%
       sizey%(lp%,0)=10 		: rem height of object hitsize, in pixels
       sizey%(lp%,1)=12 		: rem height of object spacing
    end for lp%
  endif
  xaslst=mk_asl(sizex%) 		: rem make x spacing list
  yaslst=mk_asl(sizey%) 		: rem make y spacing list
:
  DIM se%(rows%,1)			 : rem sections/row list
  for lp%= 0 TO rows%:se%(lp%,0)=lp%*cols%:se%(lp%,1)=lp%*cols%+cols%
  rwlst=mk_rwl(aolst,se%)
:
  wdeff%(0)=xsize%-16			: rem make the wdw definition
  wdeff%(1)=ysize%-inf1y-2		: rem using the global vars xsize,ysize and inf1y
  wdeff%(2)=4
  wdeff%(3)=inf1y
  rd_watt wattr%			: rem the wdw border size & colour, paper
       data 0,1,sp.appbd,sp.appbg
:
  rem make the appsub wdw
  apw(0)=mk_appw(wdeff%,wattr%,0,chr$(9),0,cdef,0,0,xaslst,yaslst,0,0,rwlst)
:
  dim main_cty%(1,2),main_mfl%(rows%,cols%-1)
  main_cty%(0,1)=1
  main_cty%(0,0)=1			: rem make the control definition
  temp%=wdeff%(1) div sizey%(0,1)	: rem how many rows fit in wdw, presumes constant y spacing
  if temp%>rows%+1:temp%=rows%+1
  main_cty%(1,2)=temp%+1
  scroll_arrows temp%+1,count%,apw(0),main_cty%: rem check wheter scroll arrows should be added
  return mk_awl(apw)			: rem  return appsub list
end def make_sprites_appsub2
:
